
from dask.distributed import Client, progress
import os
import pandas as pd
import csv
import time
import dask.dataframe 

if __name__ == '__main__':

    client = Client(n_workers=2, threads_per_worker=2, memory_limit='1GB')
    client


    header = "CMTE_ID,AMNDT_IND,RPT_TP,TRANSACTION_PGI,IMAGE_NUM,TRANSACTION_TP,ENTITY_TP,NAME,CITY,STATE,ZIP_CODE,EMPLOYER,OCCUPATION,TRANSACTION_DT,TRANSACTION_AMT,OTHER_ID,TRAN_ID,FILE_NUM,MEMO_CD,MEMO_TEXT,SUB_ID".split(",")
    PATH = "indiv20/by_date/itcont_2020_20010425_20190425.txt"
    PATH2 = "indiv20/by_date/itcont_2020_20190426_20190628.txt"

    start = time.time()

    df = dask.dataframe.read_csv(PATH, delimiter='|', header=None, names=header, dtype={'ZIP_CODE': 'object'}).loc[0:10000]
    df2 = dask.dataframe.read_csv(PATH2, delimiter='|', header=None, names=header, dtype={'ZIP_CODE': 'object'}).loc[0:10000]


    # df.set_index("NAME")
    # df = df.persist()
    # print("Persisted DF1")

    # df2.set_index("NAME")
    # df2 = df2.persist()
    # print("Persisted DF2")

    end = time.time()
    read_time = end-start

    start = time.time()

    ans = []


    ans = df.merge(df2, left_index=True, right_index=True, on="NAME").compute()


    print("found %d matches"%(len(ans)))
    print(ans)


    end = time.time()
    join_time = end-start
    print("read_time = %.2f, join_time = %.2f"%(read_time, join_time))
    # print results[0:100]

